package massim.eismassim.connection;

import java.net.Socket;

import eis.iilang.Action;

import massim.eismassim.ScenarioType;

public abstract class MASSimConnection {

	private Socket socket;
	
	public MASSimConnection() {
		throw new AssertionError("Not supposed to invoke constructor. Use factory methods instead.");		
	}
	
	protected MASSimConnection(Socket socket) {
	
		this.socket = socket;
		
	}
	
	public MASSimConnection initConnection(ScenarioType type, Object host, Object port, Object username, String password) {
	
		// TODO create socket to host + port and authorize
		Socket socket = connectToMASSimServer(host,port,username,password);

		// TODO now we have a socket and we are authorized -> create connection object
		MASSimConnection ret = null;
		if ( type == ScenarioType.mars2011 ) {
			ret = new Mars2011Connection(socket);
		}
		else {
			assert false: "Implement " + type;
		}
		
		return ret;
		
	}
	
	private Socket connectToMASSimServer(Object host, Object port, Object username, String password) {
		
		Socket ret = null;
		
		// TODO send auth-message and wait for ack -> fail by throwing an exception

		return ret;
	
	}
	
	public abstract void performAction(Action action);
	
	protected void sendMessage(Object message) {
	
		assert false : "Implement";
		
	}
	
	public boolean isAlive() {

		assert false : "Implement";
	
		return false;
		
	}
	
	
	
}
